﻿
Imports System.IO        'necessary for Load and Save Settings routines
Imports System.Text      'necessary for Encoding kind
Imports System.IO.Ports  'necessary for Serial Communication
Imports System.Threading 'necessary for Tx and Rx Delays 

Public Class frmMain

#Region "Variables"
    ''' <summary>
    ''' List of variables used in this program
    ''' </summary>
    Dim comm As Array
    Dim Even As String
    Dim Odd As String
    Dim None As String
    Dim Mark As String
    Dim Space As String
    Dim Setting As String
#End Region

#Region "User's COM Setting"
    ''' <summary>
    ''' Load port COM settings choosen by user, with all
    ''' values stored in a file named "Settings.txt"
    ''' </summary>
    Private Sub Load_Settings()
        Dim opendlg As New OpenFileDialog()
        If opendlg.ShowDialog = DialogResult.OK Then
            Dim stream As New StreamReader("Settings.txt")
            Dim sLine As String = ""
            Dim arrText As New ArrayList()
            Do
                sLine = stream.ReadLine()
                If Not sLine Is Nothing Then
                    arrText.Add(sLine)
                End If
            Loop Until sLine Is Nothing
            stream.Close()
            cboPort.Text = arrText(0)
            cboBaudrate.Text = arrText(1)
            cboParity.Text = arrText(2)
            cboFormat.Text = arrText(3)
            cboStopbit.Text = arrText(4)
            txtDelayTX.Text = arrText(5)
            txtDelayRX.Text = arrText(6)
        End If
    End Sub

    ''' <summary>
    ''' Save port COM settings choosen by user
    ''' in a file named "Settings.txt"
    ''' </summary>
    Private Sub Save_Settings()
        Dim Lastvalue(6) As String
        Lastvalue(0) = cboPort.Text
        Lastvalue(1) = cboBaudrate.Text
        Lastvalue(2) = cboParity.Text
        Lastvalue(3) = cboFormat.Text
        Lastvalue(4) = cboStopbit.Text
        Lastvalue(5) = txtDelayTX.Text
        Lastvalue(6) = txtDelayRX.Text
        Dim savedlg As New SaveFileDialog()
        If savedlg.ShowDialog = DialogResult.OK Then
            Dim stream As New StreamWriter("Settings.txt")
            Dim i As Integer
            For i = 0 To Lastvalue.Length - 1
                stream.WriteLine(Lastvalue(i))
            Next
            stream.Close()
        End If
    End Sub
#End Region

#Region "StatusStrip"
    ''' <summary>
    ''' Update Setting label with new values of: 
    ''' port COM, Baudrate, Parity, Format and StopBit
    ''' when changing combobox items. Label Status
    ''' is updated with Connect and Disconnect routines
    ''' </summary>
    Private Sub Update_Setting()
        Setting = cboPort.Text & "," & cboBaudrate.Text & "," & cboParity.Text & "," & cboFormat.Text & "," & cboStopbit.Text
        lblSetting.Text = "RS232 Setting: " & Setting
    End Sub
#End Region

#Region "MenuStrip"
    ''' <summary>
    ''' All MenuStrip Items routines
    ''' </summary>
    Private Sub LoadSettingsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoadSettingsToolStripMenuItem.Click
        Load_Settings()
    End Sub

    Private Sub SaveSettingsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveSettingsToolStripMenuItem.Click
        Save_Settings()
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        If SerialPort1.IsOpen Then
            SerialPort1.DiscardOutBuffer()
            SerialPort1.DiscardInBuffer()
            SerialPort1.Close()
        End If
        Me.Close()
    End Sub

    Private Sub ConnectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectToolStripMenuItem.Click
        comm_Open()
        If SerialPort1.IsOpen Then
            txtDelayTX.Enabled = False
            txtDelayTX.BackColor = Me.BackColor
            txtDelayRX.Enabled = False
            txtDelayRX.BackColor = Me.BackColor
            LoadSettingsToolStripMenuItem.Enabled = False
            SaveSettingsToolStripMenuItem.Enabled = False
            ConnectToolStripMenuItem.Enabled = False
            DisconnectToolStripMenuItem.Enabled = True
            Disable_All_Comboboxes()
            txtSend.Enabled = True
            txtSend.Focus()
            Setting = cboPort.Text & "," & cboBaudrate.Text & "," & cboParity.Text & "," & cboFormat.Text & "," & cboStopbit.Text
            lblSetting.Text = "RS232 Setting: " & Setting
            lblStatus.Text = "   Status: CONNECTED"
        Else
            txtDelayTX.Enabled = True
            txtDelayTX.BackColor = Color.White
            txtDelayRX.Enabled = True
            txtDelayRX.BackColor = Color.White
            LoadSettingsToolStripMenuItem.Enabled = True
            SaveSettingsToolStripMenuItem.Enabled = True
            ConnectToolStripMenuItem.Enabled = True
            DisconnectToolStripMenuItem.Enabled = False
            Enable_All_Comboboxes()
            txtSend.Enabled = False
            Setting = cboPort.Text & "," & cboBaudrate.Text & "," & cboParity.Text & "," & cboFormat.Text & "," & cboStopbit.Text
            lblSetting.Text = "RS232 Setting: " & Setting
            lblStatus.Text = "   Status: Disconnected"
        End If
    End Sub

    Private Sub DisconnectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DisconnectToolStripMenuItem.Click
        If SerialPort1.IsOpen Then
            SerialPort1.DiscardInBuffer()
            SerialPort1.Close()
            txtDelayTX.Enabled = True
            txtDelayTX.BackColor = Color.White
            txtDelayRX.Enabled = True
            txtDelayRX.BackColor = Color.White
            LoadSettingsToolStripMenuItem.Enabled = True
            SaveSettingsToolStripMenuItem.Enabled = True
            ConnectToolStripMenuItem.Enabled = True
            DisconnectToolStripMenuItem.Enabled = False
            Enable_All_Comboboxes()
            txtSend.Enabled = False
            lblStatus.Text = "   Status: Disconnected"
        End If
    End Sub

    Private Sub ClearBufferToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearBufferToolStripMenuItem.Click
        rtbDisplay.Clear()
    End Sub
#End Region

#Region "RichTextBox"
    ''' <summary>
    ''' Enable or disable RX buffer clearing
    ''' </summary>
    Private Sub rtbDisplay_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rtbDisplay.TextChanged
        If rtbDisplay.Text <> "" Then
            ClearBufferToolStripMenuItem.Enabled = True
        Else
            ClearBufferToolStripMenuItem.Enabled = False
        End If
    End Sub
#End Region

#Region "Comboboxes"
    ''' <summary>
    ''' All Comboboxes routines
    ''' </summary>
    Private Sub Enable_All_Comboboxes()
        For Each ctrl As Control In Me.GroupBox3.Controls
            If TypeOf ctrl Is ComboBox Then
                ctrl.Enabled = True
            End If
        Next
    End Sub

    Private Sub Disable_All_Comboboxes()
        For Each ctrl As Control In Me.GroupBox3.Controls
            If TypeOf ctrl Is ComboBox Then
                ctrl.Enabled = False
            End If
        Next
    End Sub

    Private Sub cboPort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboPort.SelectedIndexChanged
        Update_Setting()
    End Sub

    Private Sub cboBaudrate_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboBaudrate.SelectedIndexChanged
        Update_Setting()
    End Sub

    Private Sub cboParity_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboParity.SelectedIndexChanged
        Update_Setting()
    End Sub

    Private Sub cboFormat_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboFormat.SelectedIndexChanged
        Update_Setting()
    End Sub

    Private Sub cboStopbit_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboStopbit.SelectedIndexChanged
        Update_Setting()
    End Sub
#End Region

#Region "Form Main"
    ''' <summary>
    ''' Main form routines
    ''' </summary>
    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            Set_Port_Default()
        Catch ex As Exception
            MsgBox("No Serial Ports have been found", MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Info")
        End Try
        Update_Setting()
        lblStatus.Text = "   Status: Disconnected"
        LoadSettingsToolStripMenuItem.Enabled = True
        SaveSettingsToolStripMenuItem.Enabled = True
        DisconnectToolStripMenuItem.Enabled = False
        ClearBufferToolStripMenuItem.Enabled = False
        txtSend.Enabled = False
        RadioButton1.Checked = True
    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        If SerialPort1.IsOpen Then
            SerialPort1.DiscardOutBuffer()
            SerialPort1.DiscardInBuffer()
            SerialPort1.Close()
        End If
    End Sub
#End Region

#Region "Buttons"
    ''' <summary>
    ''' Send text, bytes, chars or integer to rs232
    ''' </summary>
    Private Sub btnSend_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSend.Click
        If RadioButton1.Checked = True Then
            Send_Text()
        ElseIf RadioButton2.Checked = True Then
            Send_Bytes(txtSend.Text)
        ElseIf RadioButton3.Checked = True Then
            Convert_Char_to_Int()
        ElseIf RadioButton4.Checked = True Then
            Convert_Int_to_Char(txtSend.Text)
        End If
    End Sub
#End Region

#Region "Radiobuttons"
    ''' <summary>
    ''' set the TX buffer max value of digits and set the focus on it
    ''' </summary>
    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        txtSend.MaxLength = 32767
        txtSend.Focus()
    End Sub

    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged
        txtSend.MaxLength = 3 'just three numbers
        txtSend.Focus()
    End Sub

    Private Sub RadioButton3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton3.CheckedChanged
        txtSend.MaxLength = 1 'just one char
        txtSend.Focus()
    End Sub

    Private Sub RadioButton4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton4.CheckedChanged
        txtSend.MaxLength = 3 'just three numbers
        txtSend.Focus()
    End Sub

#End Region

#Region "Set Port Default"
    ''' <summary>
    ''' Set port COM with default values (COM1,19200,None,8,1)
    ''' </summary>
    Private Sub Set_Port_Default()
        'Get all com ports available
        comm = IO.Ports.SerialPort.GetPortNames()
        For i = 0 To UBound(comm)
            cboPort.Items.Add(comm(i))
        Next
        'Fill cboBaudrate combobox with all values listed below
        cboBaudrate.Items.Add(110)
        cboBaudrate.Items.Add(300)
        cboBaudrate.Items.Add(600)
        cboBaudrate.Items.Add(1200)
        cboBaudrate.Items.Add(2400)
        cboBaudrate.Items.Add(4800)
        cboBaudrate.Items.Add(9600)
        cboBaudrate.Items.Add(14400)
        cboBaudrate.Items.Add(19200)
        cboBaudrate.Items.Add(28800)
        cboBaudrate.Items.Add(38400)
        cboBaudrate.Items.Add(56000)
        cboBaudrate.Items.Add(57600)
        cboBaudrate.Items.Add(115200)
        'Fill cboParity combobox with all values listed below
        cboParity.Items.Add("Even")
        cboParity.Items.Add("Odd")
        cboParity.Items.Add("None")
        cboParity.Items.Add("Mark")
        cboParity.Items.Add("Space")
        'Fill cboFormat combobox with all values listed below
        cboFormat.Items.Add(5)
        cboFormat.Items.Add(6)
        cboFormat.Items.Add(7)
        cboFormat.Items.Add(8)
        'Fill cboStopbit combobox with all values listed below
        cboStopbit.Items.Add(1)
        cboStopbit.Items.Add(2)
        'Set cboPort to the COM1 port (Sorted = True)
        cboPort.Sorted = True
        cboPort.Text = cboPort.Items.Item(0)
        'Set cboBaudrate to 19200
        cboBaudrate.Text = cboBaudrate.Items.Item(8)
        'Set cboParity to None
        cboParity.Text = cboParity.Items.Item(2)
        'Set cboFormat to 8
        cboFormat.Text = cboFormat.Items.Item(3)
        'Set cboStopbit to 1
        cboStopbit.Text = cboStopbit.Items.Item(0)
        txtDelayTX.Text = 100
        txtDelayRX.Text = 10
    End Sub
#End Region

#Region "Open port"
    ''' <summary>
    ''' Function to open port communication
    ''' </summary>
    Private Function comm_Open() As Boolean
        Try
            SerialPort1.PortName = cboPort.Text
            SerialPort1.BaudRate = cboBaudrate.Text
            SerialPort1.Parity = cboParity.SelectedValue
            SerialPort1.DataBits = cboFormat.Text
            SerialPort1.StopBits = cboStopbit.Text
            SerialPort1.ReadTimeout = ((Val(txtDelayRX.Text)) * 2)
            'set Encoding to UTF8
            SerialPort1.Encoding = System.Text.Encoding.UTF8
            If SerialPort1.IsOpen = True Then
                SerialPort1.Close()
            End If
            SerialPort1.Open()
            Return True
        Catch ex As Exception
            MsgBox(cboPort.Text & " " & "Port access denied", MsgBoxStyle.Critical + MsgBoxStyle.OkOnly, "Error")
            Return False
        End Try
    End Function
#End Region
   
#Region "Send Text"
    ''' <summary>
    ''' Send data as text to rs232
    ''' </summary>
    Private Sub Send_Text()
        Try
            SerialPort1.Write(txtSend.Text & vbCrLf)
            With rtbDisplay
                .SelectionColor = Color.Black
                .AppendText(txtSend.Text & vbCrLf)
                .ScrollToCaret()
            End With
            txtSend.Text = String.Empty
            txtSend.Focus()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Info")
        End Try
    End Sub
#End Region

#Region "Send Bytes"
    ''' <summary>
    ''' Send data as byte to rs232
    ''' </summary>
    Public Sub Send_Bytes(ByVal message As String)
        If IsNumeric(txtSend.Text) = False Then
            MsgBox("Attention: you cannot enter chars, but only numbers less than 256", MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Info")
            txtSend.Text = String.Empty
            txtSend.Focus()
        End If
        If IsNumeric(txtSend.Text) = True And Val(message) > 255 Then
            MsgBox("Attention: the number you entered is more than 255", MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Info")
            txtSend.Text = String.Empty
            txtSend.Focus()
        Else
            Dim byte_to_send(1) As Byte
            byte_to_send(1) = Val(message)
            Try
                SerialPort1.Write(byte_to_send, 1, 1)
                With rtbDisplay
                    .SelectionColor = Color.Black
                    .AppendText(txtSend.Text & vbCrLf)
                    .ScrollToCaret()
                End With
                txtSend.Text = String.Empty
                txtSend.Focus()
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Info")
            End Try
        End If
    End Sub
#End Region

#Region "Convert Char to Int"
    ''' <summary>
    ''' Send one char converted to int to rs232
    ''' </summary>
    Private Sub Convert_Char_to_Int()
        Try
            If IsNumeric(txtSend.Text) = True And (txtSend.Text) < Chr(33) Or (txtSend.Text) > Chr(126) Then
                MsgBox("Attention: you can enter only chars under the UTF8 encoding", MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Info")
                txtSend.Text = String.Empty
                txtSend.Focus()
            Else
                SerialPort1.Write(txtSend.Text)
                With rtbDisplay
                    .SelectionColor = Color.Black
                    .AppendText(txtSend.Text & vbCrLf)
                    .ScrollToCaret()
                End With
                txtSend.Text = String.Empty
                txtSend.Focus()
            End If
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Info")
        End Try
    End Sub
#End Region

#Region "Convert Int to Char"
    ''' <summary>
    ''' Send int converted to char to rs232
    ''' </summary>
    Public Sub Convert_Int_to_Char(ByVal message As String)
        Try
            If IsNumeric(txtSend.Text) = False Then
                txtSend.Text = String.Empty
                txtSend.Focus()
            End If
            If IsNumeric(txtSend.Text) = True And (txtSend.Text) < 33 Or (txtSend.Text) > 126 Or (txtSend.Text) > 256 Then
                MsgBox("Attention: you can only enter integers between 33 and 126", MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Info")
                txtSend.Text = String.Empty
                txtSend.Focus()
            Else
                Dim byte_to_send(1) As Byte
                byte_to_send(1) = Val(message)
                SerialPort1.Write(byte_to_send, 1, 1)
                With rtbDisplay
                    .SelectionColor = Color.Black
                    .AppendText(txtSend.Text & vbCrLf)
                    .ScrollToCaret()
                End With
                txtSend.Text = String.Empty
                txtSend.Focus()
            End If
        Catch ex As Exception
            MsgBox("Attention: you cannot enter chars, but only integers", MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Info")
        End Try
    End Sub
#End Region

#Region "DataReceived"
    ''' <summary>
    ''' Event handler for the DataReceived
    ''' </summary>
    Private Sub DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        rtbDisplay.Invoke(New myDelegate(AddressOf updateRTB), New Object() {})
    End Sub
#End Region

#Region "UpdateRTB"
    ''' <summary>
    ''' Delegate and subroutine to update the RichTextBox control
    ''' </summary>
    Public Delegate Sub myDelegate()
    Public Sub updateRTB()
        Try
            With rtbDisplay
                If RadioButton1.Checked = True Then
                    .SelectionColor = Color.Red
                    .AppendText(SerialPort1.ReadExisting)
                    Thread.Sleep(Val(txtDelayRX.Text))
                    .ScrollToCaret()
                ElseIf RadioButton2.Checked = True Then
                    .SelectionColor = Color.Green
                    .AppendText(SerialPort1.ReadByte)
                    Thread.Sleep(Val(txtDelayRX.Text))
                    .AppendText(vbCr)
                    txtSend.Text = String.Empty
                    txtSend.Focus()
                    .ScrollToCaret()
                ElseIf RadioButton3.Checked = True Then
                    .SelectionColor = Color.Blue
                    .AppendText(SerialPort1.ReadByte & vbCrLf)
                    Thread.Sleep(Val(txtDelayRX.Text))
                    txtSend.Text = String.Empty
                    txtSend.Focus()
                    .ScrollToCaret()
                ElseIf RadioButton4.Checked = True Then
                    .SelectionColor = Color.Maroon
                    .AppendText(SerialPort1.ReadExisting)
                    Thread.Sleep(Val(txtDelayRX.Text))
                    .AppendText(vbCr)
                    txtSend.Text = String.Empty
                    txtSend.Focus()
                    .ScrollToCaret()
                End If
            End With
        Catch ex As Exception
            MsgBox("Data reading error", MsgBoxStyle.Critical + MsgBoxStyle.OkOnly, "Error")
            SerialPort1.DiscardInBuffer()
        End Try
        Exit Sub
    End Sub
#End Region

    
End Class